package nc.ui.om.post.action;

import nc.ui.uif2.ShowStatusBarMsgUtil;
import nc.ui.uif2.IShowMsgConstant;
import nc.vo.pub.CircularlyAccessibleValueObject;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.ArrayUtils;
import java.util.ArrayList;
import nc.vo.om.joblevelsys.LevelRelationVO;
import nc.vo.om.post.AggPostVO;
import nc.ui.uif2.UIState;
import nc.ui.om.post.view.PostCardForm;
import java.awt.event.ActionEvent;
import nc.ui.om.post.model.PostModelDataManager;
import nc.ui.hr.uif2.action.SaveAction;

public class SavePostAction extends SaveAction
{
    private static final long serialVersionUID = -8246609927679233550L;
    private PostModelDataManager dataManager;
    
    public SavePostAction() {
        this.dataManager = null;
    }
    
    public void doAction(final ActionEvent evt) throws Exception {
        final Object objValue = this.getEditor().getValue();
        final PostCardForm cardView = (PostCardForm)this.getEditor();
        if (!this.getModel().getUiState().equals((Object)UIState.ADD)) {
            final CircularlyAccessibleValueObject[] hisVOs = ((AggPostVO)this.getModel().getSelectedData()).getTableVO("om_posthistory");
            ((AggPostVO)objValue).setTableVO("om_posthistory", hisVOs);
        }
        final LevelRelationVO[] visibleLevelRankVOs = (LevelRelationVO[])cardView.getBillCardPanel().getBillModel("post_levelrelation").getBodyValueVOs(LevelRelationVO.class.getName());
        final ArrayList<LevelRelationVO> allVOlist = new ArrayList<LevelRelationVO>();
        final LevelRelationVO[] LevelRankVOs = (LevelRelationVO[])((AggPostVO)objValue).getTableVO("post_levelrelation");
        if (!ArrayUtils.isEmpty((Object[])LevelRankVOs)) {
            for (final LevelRelationVO LevelRankVO : LevelRankVOs) {
                allVOlist.add(LevelRankVO);
            }
        }
        if (!ArrayUtils.isEmpty((Object[])visibleLevelRankVOs)) {
            for (final LevelRelationVO visibleLevelRankVO : visibleLevelRankVOs) {
                if (0 == visibleLevelRankVO.getStatus() && StringUtils.isNotBlank(visibleLevelRankVO.getPk_levelrelation())) {
                    visibleLevelRankVO.setStatus(1);
                    allVOlist.add(visibleLevelRankVO);
                }
            }
        }
        ((AggPostVO)objValue).setTableVO("post_levelrelation", (CircularlyAccessibleValueObject[])allVOlist.toArray((CircularlyAccessibleValueObject[])new LevelRelationVO[0]));
        this.validate(objValue);
        Object returnObj = null;
        if (this.getModel().getUiState() == UIState.ADD) {
            returnObj = this.getModel().add(objValue);
        }
        else if (this.getModel().getUiState() == UIState.EDIT) {
            returnObj = this.getModel().update(objValue);
        }
        this.getModel().setUiState(UIState.NOT_EDIT);
        ShowStatusBarMsgUtil.showStatusBarMsg(IShowMsgConstant.getSaveSuccessInfo(), this.getContext());
    }
    
    public PostModelDataManager getDataManager() {
        return this.dataManager;
    }
    
    public void setDataManager(final PostModelDataManager dataManager) {
        this.dataManager = dataManager;
    }
}
